<?php
// FILENAME: module.php - A flickr feed reader and display generator
// DATE: 05-07-14
// COPYRIGHT: 2005, Frazier Media
// AUTHOR: Christopher Frazier (cfrazier@fraziermedia.com)
// REQUIRES: Magpie RSS Reader / GDI

// Include Magpie RSS Feed Reader
require('rss/rss_fetch.inc');

// Get default variables
$sScriptPath = dirname($_SERVER['PHP_SELF']);
$sFullPath = $_SERVER['DOCUMENT_ROOT'] . '/' . $sScriptPath;

if (isset($_REQUEST['cfg'])) {$sConfigFile = $_REQUEST['cfg'];} else {$sConfigFile = 'config.ini';}
$aConfig = parse_ini_file($sConfigFile);

// Get queried variables
foreach ($aConfig as $sKey => $sValue) {
	if (isset($_REQUEST[$sKey])) {
		$aConfig[$sKey] = $_REQUEST[$sKey];
	}
}

// Set up base values from config data
$sFlickrQuery = $aConfig['baseurl'] . '?id=' . $aConfig['id'] . '&ids=' . $aConfig['ids'] . '&tags=' . $aConfig['tags'] . '&format=' . $aConfig['format'];
$sQueryHash = md5($sFlickrQuery);
$aIncludeFields = split(',', $aConfig['include_fields']);

// Pick up RSS feed
$objFeed = fetch_rss($sFlickrQuery);
$sResponseHash = md5(serialize($objFeed));
if ($aConfig['randomize']) {
	shuffle($objFeed->items);
}

$iCount = 0;
foreach ($objFeed->items as $aPhoto) {
	if ($iCount < $aConfig['count']) {
		// Get that filename
		$sDescription = $aPhoto['description'];
		$sImageURL = substr($sDescription, strpos($sDescription, '<img src="') + 10, strpos(substr($sDescription, strpos($sDescription, '<img src="') + 10), '"'));
	
		// Create preview image encoded URL
		$aPreviewInfo['width'] = $aConfig['width'];
		$aPreviewInfo['height'] = $aConfig['height'];
		$aPreviewInfo['overlay'] = $aConfig['overlay'];
		$aPreviewInfo['cache'] = $aConfig['cache'];
		$aPreviewInfo['url'] = $sImageURL;
		$sPreviewInfo = base64_encode(serialize($aPreviewInfo));
		
		// Write the image tag to be used
		$sImageTag = '<img src="http://' . $_SERVER['HTTP_HOST'] . $sScriptPath . '/preview.php?f=' . $sPreviewInfo . '" border="0" alt="' . $aPhoto['title'] . '" width="' . $aConfig['width'] . '" height="' . $aConfig['height'] . '" />';
		if ($aConfig['clickable_image']) {$sImageTag = '<a href="' . $aPhoto['link'] . '">' . $sImageTag . '</a>';}
	
		// Start creating the XHTML for this object
		if (($iCount + 1) == $aConfig['count']) {
			$sFieldsHTML = '<div id="' . md5($sImageURL) . '" class="flickr_photo_last">' . "\n";
		} else {
			$sFieldsHTML = '<div id="' . md5($sImageURL) . '" class="flickr_photo">' . "\n";
		}
		$sFieldsHTML = $sFieldsHTML . $sImageTag . "\n";
	
		// Start the look that writes out all of the fields
		foreach ($aIncludeFields as $sValue) {
			if (array_key_exists($sValue, $aPhoto)) {
				$sFieldsHTML .= '<div class="flickr_' . $sValue . '">' . $aPhoto[$sValue] . '</div>' . "\n";
			}
		}
		// Close off the object
		$sFieldsHTML = $sFieldsHTML . '</div>' . "\n";
		
		// Write out the HTML
		echo $sFieldsHTML;
		$iCount++;
	} 
}

?>